import { StyleSheet } from 'fela-tools'
import {
  APP,
  COLOR,
  HEADER
} from '../../core/constants'
import layout from '../../rules/layout/layout'
import scroll from '../../rules/scroll/scroll'
import fill from '../../rules/fill/fill'
import flex from '../../rules/flex/flex'

export default StyleSheet.create({
  app: {
    width: '100vw',
    height: '100vh',
    display: 'flex',
    overflow: 'hidden',
    minWidth: APP.MIN_WIDTH,
    backgroundColor: COLOR.FROST
  },
  menuWrapper: {
    extend: [
      layout({ direction: 'column' }),
      flex({ shrink: 0 }),
      scroll()
    ],
    belowDesktop: {
      zIndex: 1,
      position: 'fixed',
      top: HEADER.HEIGHT_SMALL,
      height: `calc(100vh - ${HEADER.HEIGHT_SMALL}px)`
    },
    aboveDesktop: {
      transform: 'translateX(0)!important'
    }
  },
  mainWrapper: {
    minWidth: 0,
    extend: [
      layout({ direction: 'column' }),
      flex({ grow: 1 })
    ]
  },
  headerWrapper: {
    position: 'relative',
    zIndex: 1,
    extend: [
      flex()
    ]
  },
  contentWrapper: {
    position: 'relative',
    extend: [
      flex({ grow: 1 })
    ]
  },
  pageWrapper: {
    extend: [
      fill(),
      scroll()
    ]
  },
  menu: {
    extend: [
      flex({ grow: 1 })
    ]
  }
})
