import { className, mergeData, renderRule } from '../../core/utils'
import rules from './link.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudLinkName',
    'croudClassName'
  ],
  props: {
    color: {
      type: Boolean,
      default: true
    },
    underline: {
      type: Boolean,
      default: true
    },
    animate: {
      type: Boolean,
      default: true
    }
  },
  render(h, ctx) {
    const tag = ctx.injections.croudLinkName
    const classes = renderRule(ctx, rules.link)
    return h(tag, mergeData(ctx, {
      class: className(ctx, 'link', classes)
    }), ctx.children)
  }
}
