import { className, mergeData, renderRule } from '../../core/utils'
import Space from '../space/space'
import rules from './panel.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String,
      default: 'div'
    },
    dim: {
      type: Boolean,
      default: false
    },
    space: {
      type: [ String, Boolean ],
      default: 'padding'
    },
    edges: {
      type: Array
    },
    overflow: {
      type: [ String, Boolean ]
    }
  },
  render(h, ctx) {
    const { edges, space } = ctx.props
    const classes = renderRule(ctx, rules.panel)
    return h(ctx.props.tag, mergeData(ctx, {
      class: className(ctx, 'panel', classes)
    }), space ? [ h(Space, {
      props: { edges, property: space }
    }, ctx.children) ] : ctx.children)
  }
}
