import named from 'fela-plugin-named-keys'
import { objectReduce } from 'fast-loops'
import { capitalize } from '../core/utils'
import { BREAKPOINT } from '../core/constants'

export const query = (value, below) => {
  const prefix = below ? 'max' : 'min'
  const offset = below ? value : value + 1
  return `@media (${prefix}-width: ${offset}px)`
}

export const queries = (breakpoints) =>
  objectReduce(breakpoints, (result, value, key) => {
    const name = capitalize(key)
    result[`below${name}`] = query(value, true)
    result[`above${name}`] = query(value, false)
    return result
  }, {})

export default (options) => named({
  placeholder: '::placeholder',
  ...queries(BREAKPOINT),
  ...options
})
